/* -*- knf -*- */
/* $AMSEL: main.h,v 1.6 2004/06/29 15:59:13 reyk Exp $ */

/*
 * Copyright (c) 2004 .vantronix | secure systems GmbH
 * Copyright (c) 2004 SSV Embedded Systems GmbH
 *
 * All rights reserved.
 *
 * Written by Reyk Floeter <reyk@vantronix.net>.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version. 
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.  *
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */

#ifndef _AMSEL_WALL_MAIN_HEADER
#define _AMSEL_WALL_MAIN_HEADER

#include <compat.h>

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <unistd.h>
#include <ctype.h>
#include <err.h>
#include <errno.h>
#include <string.h>
#include <signal.h>
#include <time.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <sys/queue.h>
#include <sys/param.h>
#include <sys/time.h>

#include <netinet/in.h>
#include <arpa/inet.h>


#define AMSELWALL_DEFAULT_CONFIG "/etc/amsel/firewall.conf"

#define AMSELWALL_OPT_VERBOSE 0x00000001
#define AMSELWALL_OPT_QUIET 0x000002
#define AMSELWALL_OPT_PATH 0x00000004
#define AMSELWALL_OPT_EDIT 0x00000008
#define AMSELWALL_OPT_KEEP 0x00000010
#define AMSELWALL_OPT_OPTIMIZE 0x00000020
#define AMSELWALL_OPT_FLUSH 0x00000040

#define AMSELWALL_ENDCHAR ';'

#ifndef fatal
#define fatal(_x) \
{ \
  fprintf(stderr, "%% Fatal <%s>\n", _x); \
  exit(EINVAL); \
}
#endif

struct amselwall_config {
	u_int32_t flags;
	u_int32_t version;
	char *path;
	TAILQ_HEAD(amselwall_table_head, amselwall_table) h_head;
};

struct keywords {
	const char *k_name;
	int k_val;
};

extern struct amselwall_config *conf;
extern int pdebug;
extern char *amwall_me;

extern int amwall_superuser(void);
extern int amwall_parse_config(void);
extern int amwall_lookup_keyword(char *, const struct keywords *, size_t);

#define amwall_is_superuser if(!amwall_superuser()) \
{ \
  amwall_print("Permission denied"); \
  return(-EPERM); \
} 

#endif /* _AMSEL_WALL_MAIN_HEADER */
