/* -*- knf -*- */
/* $AMSEL: parser.h,v 1.3 2004/02/07 14:25:14 reyk Exp $ */

/*
 * Copyright (c) 2004 .vantronix | secure systems GmbH
 * Copyright (c) 2004 SSV Embedded Systems GmbH
 *
 * All rights reserved.
 *
 * Written by Reyk Floeter <reyk@vantronix.net>.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version. 
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.  *
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */

#ifndef _AMSEL_WALL_PARSER_HEADER
#define _AMSEL_WALL_PARSER_HEADER

typedef struct {
	union {
		u_int32_t number;
		char *string;
	} v;
	int lineno;
} yy_stype_t;
	
#define YYSTYPE yy_stype_t

extern FILE *fin;
extern int lineno;
extern int errors;
extern char *infile;
extern const struct keywords keywords[];
extern const size_t keywords_size;
	

#define yyerror(_x...) \
{ \
  x_yyerror(_x); \
}

extern int x_yyerror(const char *, ...);

extern int yyparse(void);
extern int yylex(void);

extern int amwall_lookup(char *);
extern int amwall_lgetc(FILE *);
extern int amwall_lungetc(int);
extern int amwall_findeol(void);
extern int amwall_symset(const char *, const char *, int);
extern char *amwall_symget(const char *);

#endif /* _AMSEL_WALL_PARSER_HEADER */
